unit dose50; { Dos-Extender for 80x50 Display }

interface

uses  crt, dos;

const dosever : string = 'DosExt 80x50 M5.L15.W3 Key.9';
type
  WinMemP = ^WinMemR;
  WinMemR = Record
         Mem     : Array[ 1..50, 1..80] of Word;
         Last    : WinMemP;
         Mx1, My1,
         Mx2, My2  : Byte;
  end;

  DosDef = record
         Date_Time                              : word;
         time_form                              : byte;
         date_sep, time_sep, Thou_sep, dez_sep  : char;
         WorkTim                                : longint;
         TimerOn                                : boolean;
         TimePosX, TimePosY, DatePosX,
         DatePosY                               : word;
         TimeColor                              : byte;
         LastTime                               : word;
         LastDate                               : string;
         NoKeyWait                              : boolean;
         ShowExitLogo                           : boolean;
         HelpOn                                 : boolean;
         HelpEn                                 : boolean;
         HelpFile                               : string;
         FrameTyp                               : Byte;
         Shadow                                 : Boolean;
         ActWindow                              : WinMemP;
       end;

const
  DOSVar : DosDef =
         (Date_Time : 1;          { Date/Time = 0 : USA, 1: Europ, 2: Japan }
          time_form : 1;          { time format = 0: 12h, 1: 24h            }
          date_sep  : '.';        { date separator                          }
          time_sep  : ':';        { time separator                          }
          thou_sep  : #39;        { Thousands separator                     }
          dez_sep   : ',';        { decimal separator                       }
          WorkTim   : 0;          { Arbeitszeit-Speicher                    }
          TimerOn   : false;      { Zeit und Datum ausgeben                 }
          TimePosX  : 76;         { x-Position fr pdateTime                }
          TimePosY  : 1;          { y-Position                              }
          DatePosX  : 60;         { x-Position fuer Datum                   }
          DatePosY  : 1;          { y-Position fuer Datum                   }
          TimeColor : white;      { Farbe der Datum- und Zeitanzeige        }
          LastTime  : 0;          { Timeupdate                              }
          LastDate  : '';         { Dateupdate                              }
          NoKeyWait : false;      { true: Keyin wartet auf Zeichen <> nn    }
          ShowExitLogo : true;    { true: Zeigt Logo nach beenden der Unit  }
          HelpOn    : false;      { verhindert Mehrfachaufruf von Hilfe     }
          HelpEn    : false;      { erlaubt F1 = Hilfe                      }
          HelpFile  : '';         { Name der Hilfedatei                     }
          FrameTyp  : 1;          { Sonderzeichen in Frames                 }
          Shadow    : true;       { Schatten unter Fenstern                 }
          ActWindow : nil);

{.PA}
type
  KeyTyp = (AltA, AltB, AltC, AltD, AltE, AltF, AltG, AltH, AltI,
            AltJ, AltK, AltL, AltM, AltN, AltO, AltP, AltQ, AltR,
            AltS, AltT, AltU, AltV, AltW, AltX, AltY, AltZ,

            F1,   F2,   F3,   F4,   F5,   F6,   F7,   F8,   F9,   F10,   F11,   F12,
            ShF1, ShF2, ShF3, ShF4, ShF5, ShF6, ShF7, ShF8, ShF9, ShF10, ShF11, ShF12,
            CrF1, CrF2, CrF3, CrF4, CrF5, CrF6, CrF7, CrF8, CrF9, CrF10, CrF11, CrF12,
            AlF1, AlF2, AlF3, AlF4, AlF5, AlF6, AlF7, AlF8, AlF9, AlF10, AlF11, AlF12,

            CuL,   CuR,   CuUp,  CuDn,  PgHome, PgEnd,  PgUp,   PgDn,
            CrCuL, CrCuR, CrCuUp,CrCuDn,CrHome, CrEnd,  CrPgUp, CrPgDn, CrPrS,
            Alt1,  Alt2,  Alt3,  Alt4,  Alt5,   Alt6,   Alt7,   Alt8,   Alt9,   Alt0, AltHy, AltEq,
            ASCII, Help, ESC, AltEsc, RETURN, Ins, Del, CrIns, CrDel, BsP, Tab, ShTab,
            Pexit, COM1, COM2, CrRET, nn);

const
  ExtendedKey : array[0..255] of Keytyp = (
   {  0}   nn, AltEsc, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, ShTab,
   { 16}   AltQ, AltW, AltE, AltR, AltT, AltY, AltU, AltI, AltO, AltP, nn, nn, nn, nn,
   { 30}   AltA, AltS, AltD, AltF, AltG, AltH, AltJ, AltK, AltL, nn, nn, nn, nn, nn,
   { 44}   AltZ, AltX, AltC, AltV, AltB, AltN, AltM, nn, nn, nn, nn, nn, nn, nn, nn,
   { 59}   F1,   F2,   F3,   F4,   F5,   F6,   F7,   F8,   F9,   F10, nn, nn,
   { 71}   PgHome, CuUp, PgUp, nn, CuL, nn, CuR, nn, PgEnd, CuDn, PgDn, Ins, Del,
   { 84}   ShF1, ShF2, ShF3, ShF4, ShF5, ShF6, ShF7, ShF8, ShF9, ShF10,
   { 94}   CrF1, CrF2, CrF3, CrF4, CrF5, CrF6, CrF7, CrF8, CrF9, CrF10,
   {104}   AlF1, AlF2, AlF3, AlF4, AlF5, AlF6, AlF7, AlF8, AlF9, AlF10,
   {114}   CrPrS, CrCuL, CrCuR, CrEnd, CrPgDn, CrHome,
   {120}   Alt1, Alt2, Alt3, Alt4, Alt5, Alt6, Alt7, Alt8, Alt9, Alt0, AltHy, AltEq,
   {132}   CrPgUp, F11, F12, ShF11, ShF12, CrF11, CrF12, AlF11, AlF12,
   {141}   CrCuUp, nn, nn, nn, CrCuDn, CrDel, CrIns, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn);
{.PA}
const
  single : boolean = false;
  double : boolean = true;


  ex = #255;
  StandardKey : array[0..255] of char = (
           ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex,
           ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex,
           ' ','!','"','#','$','%','&','''','(',')','*','+',',','-','.','/',
           '0','1','2','3','4','5','6','7','8','9',':',';','>','=','<','?',
           '@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
           'P','Q','R','S','T','U','V','W','X','Y','Z','[','\',']','^','_',
           '`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
           'p','q','r','s','t','u','v','w','x','y','z','{','|','}','~', ex,
           ex,'', ex, ex,'', ex, ex, ex, ex, ex, ex, ex, ex, ex,'', ex,
           ex, ex, ex, ex,'', ex, ex, ex, ex,'','', ex, ex, ex, ex, ex,
           ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex,
           ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex,
           ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex,
           ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex,
           ex,'', ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex,
           ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex, ex);

  SpezialKey : array[0..255] of KeyTyp = (
           nn, nn, nn, nn, nn, nn, nn, nn, BSP, TAB, CrRET, nn, nn, RETURN, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, ESC, nn, nn, nn, nn,
           ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII,
           ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII,
           ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII,
           ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII,
           ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII,
           ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII, ASCII,
           nn, ASCII, nn, nn, ASCII, nn, nn, nn, nn, nn, nn, nn, nn, nn, ASCII, nn,
           nn, nn, nn, nn, ASCII, nn, nn, nn, nn, ASCII, ASCII, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, ASCII, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn,
           nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn, nn);
{.PA}

function  dby(db:word):string;
function  ldby(db:word):string;
function  hex(db:word):string;
function  lhex(db:word):string;
function  lreal(db:real; i,j:integer):string;
function  lint(db:longint; i:integer):string;
function  lintnp(db:longint; i:integer):string;
function  lintlz(db:longint; i:integer):string;
function  bitstr( db: byte):string;

Function  upStr( str : string) : string;

procedure beep;
procedure lbeep;

procedure Cursor(CuH,CuL: byte);
procedure CursorOff;
procedure CursorOn;
procedure CursorBlock;

function  Date:string;
function  Time:string;
procedure ResTim;
function  GetTim:string;
function  Tim : Longint;
procedure updateTime;
function  DayOfYear(t:string): word;
function  DateOfDay(i,j:word): string;

function  Keyin(var c:char):KeyTyp;

procedure scrWinClr(a,x1,y1,x2,y2: byte);        { Bildfenster loeschen        }
procedure scrWinUp (x1,y1,x2,y2: byte);          { Bildfenster verschieben     }
procedure scrWinDn (x1,y1,x2,y2: byte);          { Bildfenster verschieben     }
procedure scrWinTxt(a,x,y: byte; t: string);     { Zeichenkette an Pos. ausgeben}
procedure filWinChr(a,x,y: byte; n : Word; c: char);
Procedure ScrWinTxtC( a, x, y, l : Byte; str : String);
Procedure ScrWinTxtZ( a, x, y, d : Byte; str : string);
Procedure ScrColText( a, x, y, l : Byte);

Procedure LineWindow( a, x1, y1, x2, y2, d : Byte; as : Byte; s : string);
Procedure LineWindowZ( a, xd, yd, d : byte; as : byte; s : string);
Procedure Lines( a, x1, x2, y, d : Byte);

Procedure MenuLine( a, a2, y : Byte; str : String);

Procedure InsertWindow( a, x1, y1, x2, y2, d : byte; as : byte; s : string);
Procedure KillWindow;

Var Win_Scroll : Word;
    VMemW      : Array[ 1.. 50, 1.. 80] of Word absolute $B800:0000;

implementation

const
  mon : array[1..13] of integer =
              (00,31,59,90,120,151,181,212,243,273,304,334,365);

Type WinPtr = ^WinRec;
     WinRec = Record
       LastWin: WinPtr;
       Window : Pointer;
       Size   : Word;
       px1, py1,
       lx, ly : Byte;
     end;

var
  reg   : Registers;      { Speicher-Feld fuer MSDOS Aufrufe      }
  ScrSav: array[0..4000] of byte; { Speicher fuer Hilfsbildschirm }
  ActWin : WinPtr;
  ExitChainP : Pointer;

{.PA}
{******************     1. Zahlendarstellung     ********************}

function dby;

begin
  if db > 99 then dby := '>' + chr($30 +(db mod 10)) else
    dby := chr($30 +(db div 10)) + chr($30 +(db mod 10));
end;

function ldby;

begin ldby := dby(db div 100) + dby(db mod 100);end;

function nib (db : integer): char;

begin
  db := db and $F or $30; if db > $39 then db := db + 7; nib := chr(db);
end;

function hex;

begin hex := nib(db shr 4) + nib(db); end;

function lhex;
begin lhex := hex(hi(db)) + hex(lo(db)); end;

function lreal;
var t: string;   k: integer;
begin
  with DosVar do begin
    str(db:i:j,t); k := 3;
    if j <> 0 then t[i-j] := dez_sep else j := -1;
{    while  k < i-j do begin
      if t[i-j-k-1] <> ' ' then begin
        insert(thou_sep,t,i-j-k);
        if t[1] = '.' then delete(t,1,1); end;
      k := k + 4; end;} end;
  lreal := t;
end;


function lint;
var t: string;
    k,j: integer;
begin
  j := 0;
  with DosVar do begin
    str(db:i,t); k := 3;
    {while (t[1] = ' ') and (k < i) and (t[i-k] <> ' ') do begin
      insert(thou_sep,t,i-k+1); delete(t,1,1);
      k := k + 3; end;}
  end;
  lint := t;
end;


function lintnp;
var s: string;
begin
  str(db:i,s);
  lintnp := s;
end;


function lintlz;
var s: string;
begin
  str(db,s);
  while length( s) < i do insert( '0', s, 1);
  lintlz := s;
end;


Function BitStr( db: Byte):string;
var i : byte;
    t : string;
begin
  t := '';
  for i := 7 downto 0 do
    if db and ( 1 shl i) <> 0 then t := t + '1' else t := t + '0';
  BitStr := t;
end;


Function UpStr( str : string) : string;
var w : word;
begin
  for w := 1 to ord( str[0]) do UpStr[ w] := upcase( str[ w]);
  UpStr[0] := str[ 0];
end;

{.PA}
{******************     2. Tongenerator          ********************}
procedure beep;

begin
  Sound(300); Delay(20);
  Sound(950); Delay(20);
  NoSound;
end;

procedure lbeep;

var i: integer;

begin
  for i := 0 to 3 do beep;
end;
{.PA}
{******************     3. Cursor veraendern     ********************}

procedure Cursor(cuh,cul: byte);           {****** Cursor setzen ******}

begin
  with reg do begin
    ax := $0100;
    cx := cuh shl 8 + cul;
    intr($10,reg);
  end;
end;


procedure CursorOff;              {****** Cursor ausschalten ******}

begin
  Cursor(15,0);
end;


procedure CursorOn;               {****** Cursor einschalten ******}

begin
  Cursor(6,7);
end;


procedure CursorBlock;            {****** Cursor in Blockmod ******}

begin
  Cursor(0,7);
end;

{.PA}
{******************     4. Datum und Uhrzeit     ********************}

function Date;

var  y,mo,da,dw : word;

begin
  GetDate(y,mo,da,dw); with DOSVar do
    Date :=dby(da) + Date_sep + dby(mo) + Date_sep + dby(y mod 100);
end;

function Time;

var h,m,s,ms : word;

begin
  GetTime(h,m,s,ms); with DOSVar do
    Time := dby(h) + Time_sep + dby(m) + Time_sep + dby( s);
end;

function Tim: longint;        {****** Zeit fuer Timer einlesen ******}

begin
  with reg, DosVar do begin
    ax := $2C00;             { MS-DOS Aufruf : Zeit                  }
    MsDos(reg);
    Tim := cx SHL 8 OR dl;
  end;
end;

procedure ResTim;                       {****** Timer loeschen ******}

begin DosVar.WorkTim := Tim end;

function GetTim : string;              {****** Timer auslesen ******}

var t     : longint;
    h,m,s : integer;

begin
  t := Tim - DosVar.WorkTim;
  if t <= 0 then t := 1;
  h := t div 3600; m := (t - 3600 * h) div 60; s := t mod 60;
  GetTim := dby(h)+':'+ dby(m)+':'+ dby(s);
end;

procedure UpdateTime;

var h,m,s,ms : word;

begin
  if DOSVar.TimePosX <> 0 then with DOSVar do begin
    GetTime(h,m,s,ms);
    if LastTime <> s then begin
      LastTime := s;
      scrWintxt(DosVar.TimeColor,TimePosx,TimePosy,dby(h) + Time_sep + dby(m) + #32 + dby(s)); end; end;
end;
{.PA}

function DayOfYear;    { Nummer des Tages       }

function dezi(i: integer): integer;

begin
  dezi := 10 *(ord(t[i]) -$30) +(ord(t[i+1]) -$30);
end;

var  i, j   : integer;


begin
  if DosVar.date_time <> 0 then begin
    i := mon[dezi(4)];
    if ( i>59 ) and ( (dezi(9) mod 4) = 0 ) then i := i +1;
    DayOfYear := i +dezi(1); end
  else begin
    i := mon[dezi(1)];
    if ( i>59 ) and ( (dezi(9) mod 4) = 0 ) then i := i +1;
    DayOfYear := i +dezi(4); end;
end;

function DateOfDay;  { Datum aus Tagesnummer
                                                und Jahr             }
var k,m :integer;
    l   :string[4];

begin
  k := 1;
  while mon[k+1] <i do k := k+1;
  if DosVar.date_time <> 0 then
    DateOfDay := dby(i-mon[k]) + ' ' + dby(k) + ' ' + ldby(j) else
    DateOfDay := dby(k) + ' ' + dby(i-mon[k]) + ' ' + ldby(j);
    DateOfDay[3] := DosVar.date_sep;
    DateOfDay[6] := DosVar.date_sep;
end;

procedure UpdateDate;

begin
  if DOSVar.DatePosX <> 0 then with DOSVar do begin
    if LastDate <> Date then begin
      LastDate := Date;
      scrWintxt(TimeColor,DatePosx,DatePosy, Date); end; end;
end;
{.PA}

(*procedure Maske(m:maske.def);

var i: integer;

begin
  with m do begin
    ScrWinClr(1,Y1,80,Y2);
    for i := 0 to Y1 - Y2 do ScrWinTxt(15,1,Y1 +i,Text(i);
  end;
end;
  *)


{.PA}
{******************     6. Tastatur einlesen     ********************}

Procedure Helper;
var hfil  : text;
    y     : Byte;
    kc    : KeyTyp;
    c     : Char;
    DosVB : DosDef;
    str   : string;
begin
  DosVB := DosVar;
  DosVar.NoKeyWait := false;
  DosVar.HelpOn    := true;
  InsertWindow( $3E, 1, 3, 80, 22, 4, $3E, 'HILFE');
  Assign( hfil, DosVar.HelpFile);
  {$I-}
  Reset( hfil);
  {$I+}
  If IOResult = 0 then begin
    y := 4;
    While ( not eof( hfil)) and ( y < 22) do begin
      Readln( hfil, str);
      ScrWinTxt( $30, 3, y, copy( str, 1, 76));
      inc( y);
    end;
  end;
  ScrWintxt( $3E, 3, 22, 'ESC');
  kc := KeyIn( c);
  KillWindow;
  DosVar := DosVB;
end;


function Keyin;

var a : KeyTyp; b : byte; p: boolean;

begin
  with reg do begin
  p := true; Keyin := nn; c := #0;
  repeat
    while p do begin
      if DosVar.TimerOn then begin UpdateTime; UpdateDate; end;
      ah := $11; intr($16,reg); p := (flags and FZero) <> 0;
    if p and DOSvar.nokeywait then exit; end;
    ah := $10; intr($16,reg);
    if (al = 0) or (al = $E0) then begin
      if al = $E0 then case ah of
                         4  : ah := 132;
                        13  : ah := 141;
                        17  : ah := 145;
                       end;
      a := ExtendedKey[ah]; end
    else a := SpezialKey[al];
  until a <> nn;
  c := StandardKey[al]; Keyin := a;
  end;
  If (a = F1) and DosVar.HelpEn and ( not DosVar.HelpOn) then begin
    Helper;
    Keyin := nn;
  end;
end;

{.PA}
{******************     7. Bildschirmaufrufe     ********************}

procedure scrWinClr(a,x1,y1,x2,y2:byte);         { Bildfenster loeschen        }
begin
  with reg do begin
    ax := $0600; bh := a;
    cx := (y1 -1) shl 8 or (x1 -1);
    dx := (y2 -1) shl 8 or (x2 -1);
    intr($10,reg); end;
end;


procedure scrWinUp(x1,y1,x2,y2: byte);           { Bildfenster verschieben     }

begin
  with reg do begin
    ax := $0601; bh := $07;
    cx := (y1 -1) shl 8 or (x1 -1);
    dx := (y2 -1) shl 8 or (x2 -1);
    intr($10,reg); end;
end;

procedure scrWinDn(x1,y1,x2,y2: byte);         { Bildfenster verschieben     }

begin
  with reg do begin
    ax := $0701; bh := $07;
    cx := (y1 -1) shl 8 or (x1 -1);
    dx := (y2 -1) shl 8 or (x2 -1);
    intr($10,reg); end;
end;


Procedure ScrWinTxt( a, x, y : Byte; t : String);
var i : Byte;
begin
  For i := 1 to length( t) do
    VMemW[ y, x+pred( i)] := $0000 or (a shl 8) or ord( t[ i]) ;
end;

Procedure ScrWinTxtC( a, x, y, l : Byte; str : String);
var i : Byte;
    s : string;
begin
  s := copy( str, 1, l);
  ScrWinTxt( a, x, y, s);
  For i := length( s) to pred( l) do ScrWinTxt( a, x+i, y, #32);
end;


procedure filWinChr(a,x,y: byte; n : Word; c: char);
var i : Word;
begin
  For i := 0 to Pred( n) do VMemW[ y, x+ i] := a shl 8 or ord( c);
end;


Procedure ScrColText( a, x, y, l : byte);
var i : byte;
begin
  for i := 0 to pred( l) do VMemW[ y, x+i] := (VMemW[ y, x+i] and $00FF) or (a shl 8);
end;


Procedure Lines( a, x1, x2, y, d : Byte);
const charset : array[ 1..4, 1.. 6] of char =
                  (('','','','','',''),
                   ('','','','','',''),
                   ('','','','','',''),
                   ('','','','','',''));
var x : byte;
begin
  For x := x1 to x2 do begin
    ScrWinTxt( a, x, y, charset[ d, 1]);
    ScrWinTxt( a, x, y, charset[ d, 1]);
  end;
end;


Procedure LineWindow( a, x1, y1, x2, y2, d : byte; as : byte; s : string);
const charset : array[ 1..4, 1.. 8] of char =
                  (('','','','','','', '', ''),
                   ('','','','','','', '', ''),
                   ('','','','','','', '', ''),
                   ('','','','','','', '', ''));
var x : byte;
begin
  ScrWinClr( a, x1, y1, x2, y2);
  lines( a, succ(x1), pred(x2), y1, d);
  lines( a, succ(x1), pred(x2), y2, d);

  For x := succ( y1) to pred( y2) do begin
    ScrWinTxt( a, x1, x, charset[ d, 2]);
    ScrWinTxt( a, x2, x, charset[ d, 2]);
    if DosVar.Shadow and (x2<80) then ScrColText( $07, x2+1, x, 1);
  end;

  if DosVar.Shadow and (y2<25) then ScrColText( $07, X1+1, y2+1, x2-x1+1);

  Scrwintxt( a, x1, y1, charset[ d, 3]);
  Scrwintxt( a, x2, y1, charset[ d, 4]);
  Scrwintxt( a, x1, y2, charset[ d, 5]);
  Scrwintxt( a, x2, y2, charset[ d, 6]);

  if s[0] > #00 then begin
    x :=  x1+(x2-x1-(length( s))) div 2+1;
    ScrWinTxt( as, x, y1, s);
    ScrWInTxt( a, pred( x), y1, charset[ d, 7]);
    ScrWInTxt( a, x+length( s), y1, charset[ d, 8]);
  end;
end;


Procedure LineWindowZ( a, xd, yd, d : byte; as : byte; s : string);
begin
  LineWindow( a, (80 - xd) div 2, ( 25 - yd) div 2, ((80 - xd) div 2)+xd, ((25 - yd) div 2)+yd, d, as, s);
end;
Procedure InsertWindow( a, x1, y1, x2, y2, d : byte; as : byte; s : string);
Var WindowMem : WinMemP;
    x, y      : Word;
begin
  New( WindowMem);
  With WindowMem^ do begin
    Mx1 := x1;
    My1 := y1;
    Mx2 := x2;
    My2 := y2;
    For y := y1 to succ( y2) do for x := x1 to succ( x2) do Mem[ y, x] := VMemW[ y, x];
    Last := DosVar.ActWindow;
  end;
  DosVar.ActWindow := WindowMem;
  LineWindow( a, x1, y1, x2, y2, d, as, s);
end;


Procedure KillWindow;
Var lastWin : WinMemP;
    x, y    : Word;
begin
  If DosVar.ActWindow <> nil then begin
    With DosVar.ActWindow^ do begin
      LastWin := Last;
      For y := My1 to succ( My2) do for x := Mx1 to succ( Mx2) do VMemW[ y, x] := Mem[ y, x];
    end;
    Dispose( DosVar.ActWindow);
    DosVar.ActWindow := LastWin; end
  else begin
    Writeln( 'ERROR in '+DOSEVER+': request to kill non existent window!');
    halt(1);
  end;
end;


Procedure ScrWinTxtZ( a, x, y, d : Byte; str : string);
const leer = '                                        ';
var s : string;
begin
  s := copy( leer, 1, (d-length( str)) div 2);
  s := s+str+s;
  if length( s) < d then s := s+' ';
  ScrWinTxt( a, x, y, s);
end;

Procedure MenuLine( a, a2, y : Byte; str : string);
var i, n : Byte;
    c : Byte;
begin
  c := a;
  n := 1;
  With DosVar do begin
    for i := 1 to 80 do VMemW[y, i] := $0020 or ( a shl 8);
    for i := 1 to length( str) do begin
      if str[ i] = '~' then if c=a then c:=a2 else c:=a else begin
        VMemW[ y, n] := c shl 8 or ord( str[ i]);
        inc( n);
      end;
    end;
  end;
end;



{.PA}
{******************    Initialisierung    ****************}

{$F+}
Procedure DeInit;
begin
  If DosVar.ShowExitLogo then begin
    TextColor( $0E);
    Writeln( DosEVer);
    TextColor( $07);
  end;
  ExitProc := ExitChainP;                          {- Restore ExitProc-}
end;
{$F-}


Procedure Init;
begin
  ExitChainP := ExitProc;                          {- Save ExitProc-}
  ExitProc   := @DeInit;                           {- Set ExitProc-}
end;

Begin
  Init;
end.


var Lbuf : array[0..33] of char;

begin
  DirectVideo := true; CheckSnow := false;
  with reg, DosVar do begin
    intr($11,reg);
    ax := $3800; ds := seg(Lbuf); dx := ofs(Lbuf);
    MsDos(reg);                                     { DOS-Variablen auslesen }
    Date_Time := ord(lbuf[0]); Time_Form := ord(lbuf[17]);
    Date_sep  := lbuf[11];     Time_sep  := lbuf[13];
    Thou_sep  := lbuf[7];      Dez_sep   := lbuf[9];
    ActWindow := nil;
  end;
  Win_Scroll := 20;
  Init;
end.
