UNIT GLCD;

Interface


Procedure GLCD_cmd( b : Byte);
Procedure GLCD_dat( b : Byte);
Procedure GLCD_init;
Procedure GLCD_Text;
Procedure GLCD_Test;
Procedure GLCD_Loop;


Implementation

Uses DOS, CRT, PUMP, DOSE50;

Procedure GLCD_cmd( b : Byte);
begin
  writex( $2, b);
end;

Procedure GLCD_dat( b : Byte);
begin
  writex( $3, b);
end;

Procedure GLCD_Status;
begin
  ScrWinTxt( $70, 12, 1, bitstr( readx( $2)));
end;

Procedure GLCD_init;
begin

  { System Setup Command }
  glcd_cmd( $40);      { Start Init-Sequence                  }
  glcd_dat( $30);      { LCD Panel Hardware Setup             }
  glcd_dat( $87);      { Character Width in Pixels = 7        }
  glcd_dat( $07);      { Character Height in Pixels-1 = 7     }
  glcd_dat( $27);      { Address Range for 1 Text Line-1 = 39 }
  glcd_dat( $39);      { Line Length in Characters = 39       }
  glcd_dat( $ef);      { Number of Lines per Frame = 240      }
  glcd_dat( $28);      { Horizontal Address Range (Text)      }
  glcd_dat( $00);      { = 40                                 }

  { Scroll Parameters }
  glcd_cmd( $44);      { Call Scroll Paramerter Setup }
  glcd_dat( $00);
  glcd_dat( $00);
  glcd_dat( $ef);
  glcd_dat( $b0);
  glcd_dat( $04);
  glcd_dat( $ef);
  glcd_dat( $00);
  glcd_dat( $00);
  glcd_dat( $00);
  glcd_dat( $00);

  { Cursor Form }
  glcd_cmd( $5d);
  glcd_dat( $04);      { Width of Cursor  }
  glcd_dat( $68);      { Heigth of Cursor }

  { Cursor Direction }
  glcd_cmd( $4c);      { Cursor Direction in Auto Write Mode = Right }

  { Horizontal Scroll Rate }
  glcd_cmd( $5a);
  glcd_dat( $00);      { Scroll One Pixel at a Time }

  { Overlay }
  glcd_cmd( $5b);
  glcd_dat( $01);      { Text / Graphics Overlay Mode (EXOR) }

  { Display On/Off }
  glcd_cmd( $59);
  glcd_dat( $16);      { Displpay On }
end;


Procedure GLCD_Text;
begin
  glcd_cmd( $46);      { Cursor Position }
  glcd_dat( $31);
  glcd_dat( $02);

  glcd_cmd( $42);      { Write Text }
  glcd_dat( ord( 'T'));
  glcd_dat( ord( 'E'));
  glcd_dat( ord( 'S'));
  glcd_dat( ord( 'T'));
end;

Procedure GLCD_Loop;
var c : char;
begin
  repeat
  glcd_cmd( $00);
  glcd_dat( $24);
  until keypressed;
  c:= readkey;
end;

var kc   : Keytyp;
    c    : char;
    scr  : Byte;
    sdv  : Byte;

const GLCDMenu   : string = ' GLCD Menu  ~F1~ Init  ~F2~ Test                                         ~ESC~ Exit ';
      scrol      : Array[ 0..7] of char = ('', '', '', '', '', '', ' ', ' ');

Procedure Scroller;
begin
  dec( sdv);
  if sdv = 0 then begin
    inc( scr);
    ScrWinTxt( $72, 2, 1, scrol[scr and $03]+'          ');
    sdv := 100;
  end;
end;


Procedure GLCD_Test;
begin

  MenuLine( $70, $74, 25, GLCDMenu);

  repeat
    Scroller;

    kc := keyin( c);
    case kc of
      F1    : GLCD_init;
      F2    : GLCD_TEXT;
      F3    : GLCD_Loop;
    end;
  until kc = ESC;
end;

begin
  sdv := 100;
end.




