Unit OLM;

interface

procedure OnlineMode;

implementation


uses dos, pump, crt, dose50, glcd;

Type str3  = String[3];
     str16 = String[ 16];

     Tlcd  = record
        styp : str16;
        btyp : Byte
     end;

const scrol   : Array[ 0..7] of char = ('|', '/', '-', '\', '|', '/', '-', '\');
      Alcd    : Array[ 0..6] of Tlcd =
       ((styp:' NO INIT '; btyp:$00),
        (styp:'INIT 2x16'; btyp:$01),
        (styp:'INIT 2x20'; btyp:$02),
        (styp:'INIT 4x16'; btyp:$03),
        (styp:'INIT 4x20'; btyp:$04),
        (styp:'INIT AUTO'; btyp:$FE),
        (styp:'INIT ONLY'; btyp:$FF));

Var   i       : Byte;
      lcd_wi,
      lcd_he  : Byte;
      lcd_me  : Array[ 0..4, 0..40] of Byte;
      lcd_sel : Boolean;

      Counter : Real;
      LastTime : string;

Procedure OnlineMode;
var kc     : KeyTyp;
    c      : Char;
    scr    : Byte;
    KeyBuf : Array[ 0..3] of Byte;
    IrBuf  : Array[ 0..3] of Word;
    KeyTgl : Byte;
    IRtgl  : Byte;
    EncBuf : Array[ 0..3] of Byte;
    encTgl : Byte;

Const MainMenu   : string = '                 ~F5~ GLCD  ~F6~ LCD  ~F7~ SER/PAR  ~F9~ Config  ~F10~ Reset  ~Alt+X~ Exit ';
      ConfigMenu : string = ' PUMP Config  ~TAB~ Item        ~'#27#26'~ Select  ~'#24#25+
                            '~ Toggle  ~ESC~ Back  ~'#17'~ Save & Exit';
      LCDMenu    : string = ' LCD Menu  ~F1~ Clear  ~F2~ Home  ~F3~ Toggle 4x40  ~F4~ Blast!             ~ESC~ Exit ';

  Procedure Scroller;
  begin
    inc( scr);
    ScrWinTxt( $72, 2, 1, scrol[scr and $03]);
  end;


  Procedure ShowLPTConf;
  begin
    ScrWinTxt( $70, 3, 3, 'LPT: '+lhex( lpt)+'    ');
    case readserial of
      true : ScrWinTxt( $1e, 3, 4, 'Mode: Serial');
      false: ScrWinTxt( $1e, 3, 4, 'Mode: Parallel');
    end;
  end;

Procedure ShowPUMPcfg;
  var   p, l, c : Byte;
        s : string;
begin
  ScrWinTxt( $70, 21,  3, ' PUMP Config 01FC ');
  p := GetPUMPcfg;
  l := GetPUMPlcd;
  c := getContrast;
  ScrWinTxt( $1e, 31,  4, bitstr( p));
  s:=hex( l)+':';
  case l of
    $00 : s:=s+' NO INIT ';
    $01 : s:=s+'INIT 2x16';
    $02 : s:=s+'INIT 2x20';
    $03 : s:=s+'INIT 4x16';
    $04 : s:=s+'INIT 4x20';
    $FE : s:=s+'INIT AUTO';
    $FF : s:=s+'INIT ONLY';
    else s:= s+'!ILLEGAL!';
  end;
  ScrWinTxt( $1e, 3, 10, s);

  ScrWinTxt( $1F, 3, 11, 'CTRST: '+ldby( c)+'d');
  ScrWinTxt( $1F, 3, 12, 'BACKL: '+ldby( GetBacklight)+'d');

end;


  Procedure ShowPUMPStat;
  begin
    ScrWinTxt( $1e, 46,  4, bitstr( Readx(0)));
  end;

  Function PUMPKey : Boolean;
  begin
    PUMPKey := (Readx( $00) and $20) <> 0;
  end;


  Function GetPUMPKey : Byte;
  begin
    writex($01,$12);
    GetPUMPKey := readx( $01);
  end;


  Procedure ShowKeyBuf;
  var i : byte;
  begin
    For i := 0 to 3 do ScrWinTxt( $1e, 68, 4+i, hex( KeyBuf[3-i])+':'+bitstr( KeyBuf[ 3-i]));
  end;


  Function PUMPenc : Boolean;
  begin
    PUMPenc := (Readx( $00) and $40) <> 0;
  end;


  Function GetPUMPenc : Byte;
  begin
    writex($01,$14);
    GetPUMPenc := readx( $01);
  end;


  Procedure ShowEncBuf;
  var i : byte;
  begin
    For i := 0 to 3 do ScrWinTxt( $1e, 56, 4+i, hex( EncBuf[3-i])+':'+bitstr( EncBuf[ 3-i]));
  end;


  Function PUMP_IR : Boolean;
  begin
    PUMP_IR := (Readx( $00) and $10) <> 0;
  end;


  Function GetPUMPIr : Word;
  var w : word;
  begin
    writex($01,$11);
    w := readx( $01) shl 8;
    writex( $01, $10);
    w := w or readx( $01);
    GetPUMPIr := w;
  end;


  Procedure ShowIrBuf;
  var i : byte;
  begin
    For i := 0 to 3 do
      ScrWinTxt( $1e, 56, 9+i, lhex( IrBuf[3-i])+':'+bitstr( hi( IrBuf[ 3-i]))+'--'+bitstr( lo( IrBuf[3-i])));
  end;



  Procedure ConfigPUMP;
  var mp, cp, crt,
      p, l,
      topic   : Byte;
      s       : String;

    Procedure SelPUMPlcd( kc : KeyTyp);
    begin
      case kc of
        CuUp :   case l of
                   $01..$04, $FF : dec( l);
                   $FE           : l := $04;
                 end;
        CuDn :   case l of
                   $00..$03, $FE : inc( l);
                   $04           : l := $FE;
                 end;
      end;
    end;


    Procedure SetPUMPcfg2( kc : KeyTyp);
    begin
      case kc of
        CuL    : cp := (cp+1) and 7;
        CuR    : cp := (cp-1) and 7;
        CuDn   : p := p xor (1 shl cp);
        CuUp   : p := p xor (1 shl cp);
      end;
    end;


  Procedure SetPUMpCtrst( kc : Keytyp);
  begin
    case kc of
      CuUp : inc( crt);
      CuDn : dec( crt);
    end;
    Seteeprom( P_contrast, crt);
  end;


  begin
    CursorON;
    cp := 7;

    p := GetPUMPcfg;
    l := GetPUMPlcd;
    crt := GetEEprom( P_contrast);

    MenuLine( $70, $74, 25, ConfigMenu);
    DosVar.NoKeyWait := false;

    topic := 0;

    repeat

      ScrWinTxt( $1e, 31, 4, bitstr( p));
      s:=hex( l)+':';
      case l of
        $00 : s:=s+' NO INIT ';
        $01 : s:=s+'INIT 2x16';
        $02 : s:=s+'INIT 2x20';
        $03 : s:=s+'INIT 4x16';
        $04 : s:=s+'INIT 4x20';
        $FE : s:=s+'INIT AUTO';
        $FF : s:=s+'INIT ONLY';
        else s:= s+'!ILLEGAL!';
      end;
      ScrWinTxt( $1e, 3, 10, s);
      ScrWinTxt( $1f, 10, 11, lhex( crt));

      case topic of
        0 : Gotoxy( 31+7-cp, 4);
        1 : GotoXY( 3, 10);
        2 : GotoXY( 10, 11);
      end;

      kc := KeyIn(c);

      case kc of
        TAB    : if Topic < 2 then inc( Topic) else Topic := 0;

        RETURN : SetEEPROM( $1FC, p);
        ESC    : p := GetPUMPCfg;
        else
          case topic of
            0 : SetPUMPcfg2( kc);
            1 : SelPUMPlcd( kc);
            2 : SetPUMPctrst( kc);
          end;
      end;
    until kc in [ ESC, RETURN];
    if kc = RETURN then begin
      setPUMPcfg( p);
      setPUMPlcd( l);
      ResetPUMP;
      Delay( 200);
    end;

    CursorOFF;
    DosVar.NoKeyWait := true;
    MenuLine( $70, $74, 25, MainMenu);
    ShowPUMPcfg;
  end;


Procedure LCD_Write( c: char);
begin
  writex( $3, ord( c));
end;


Procedure LCD_Toggle;
begin
  case lcd_sel of
    true  : begin writex( $1, $41); lcd_sel := false; end;
    false : begin writex( $1, $40); lcd_sel := true; end;
  end;
end;


Procedure LCD_Clear;
begin
  writex( $2, $1);
  LCD_Toggle;
  writex( $2, $1);
  if not lcd_sel then LCD_Toggle;
end;


Procedure ShowLCDDim;
var dim : Byte;
begin
  GetDispDim;
  For i := 1 to 4 do LCDbuf[i] := '1<-- Line'+lint( i,1)+' -->16->20               -->40';
  UpdateDisp;
end;


Procedure LCD_Test;
var kc    : KeyTyp;
    c     : Char;
    x, y  : Byte;
    blast : Boolean;
    blc   : char;

  Procedure LCD_Home;
  begin
  writex( $2, $2);
  end;

  Procedure Blast_Disp;
  begin
    LineWindow( $70, 2, 14, 79, 20, 2, $70, 'Blast the LCD...');
    ScrWinTxt( $7E,  4, 15, 'Time per Frame: ');
    ScrWinTxt( $70,  4, 17, 'Continuous writing to the display for evaluating timing probelms or ');
    ScrWinTxt( $70,  4, 18, 'measuring with oszylloscope.');
    ScrWinTxt( $70, 66, 19, 'Stop with F4');
  end;

  Procedure Blast_Clear;
  begin
    ScrWinClr( $1f, 2, 14, 79, 20);
    LCD_clear;
  end;

  Procedure LCD_Blast;
  var x, y : Byte;
  begin
    for y := 1 to 4 do begin
      for x := 1 to 40 do LCDbuf[y][x] := blc;
      LCDbuf[y][0] := #40;
    end;
    UpdateDisp;
    inc( blc);

    counter := counter + 1;

    if Time <> LastTime then begin
      ScrWinTxt( $70, 20, 15, lreal( 1/counter*1000, 2, 4)+'ms    ');
      counter := 0;
      LastTime := Time;
    end;

  end;

begin
  MenuLine( $70, $74, 25, LCDMenu);
  blast := false;
  repeat
    kc := keyIn(c);

    case kc of
      ASCII : LCD_Write( c);
      F1    : LCD_Clear;
      F2    : LCD_Home;
      F3    : LCD_Toggle;
      F4    : begin
                blast := not blast;
                if blast then Blast_Disp else Blast_Clear;
                counter := 0;
              end;
    end;

    if blast then LCD_Blast;

  until kc = ESC;
  Blast_Clear;
  ShowLCDdim;
  MenuLine( $70, $74, 25, MainMenu);
end;


begin
  CursorOff;
  ScrWinClr( $1f, 1, 1, 80, 25);
  DosVar.Shadow := false;
  LineWindow( $1F,  1,  2, 80, 24, 2, $1F, '');
  LineWindow( $10, 66, 21, 78, 23, 2, $10, 'Version');
  ScrWinTxt( $10, 80-length( version)-2, 22, 'R'+RelDate);
  ScrWinTxt( $10, 80-length( version)-2, 23, version);
  ScrWinTxtZ( $74, 1, 1, 80, 'PCFG DIAG-Mode');
  MenuLine( $70, $74, 25, '                                                         ~F10~ Reset  ~Alt+X~ Exit ');
  DosVar.NoKeyWait := true;
  LCD_sel := false;


  { PUMP STATUS }
  ScrWinTxt( $20, 41,  3, ' PUMP STATUS ');
  ScrWinTxt( $1F, 41,  5, ' --  ٳ');
  ScrWinTxt( $1F, 41,  6, ' ENC ٳ');
  ScrWinTxt( $1F, 41,  7, ' KEY ٳ');
  ScrWinTxt( $1F, 41,  8, ' IR  ٳ');
  ScrWinTxt( $1F, 41,  9, ' ENC1ٳ');
  ScrWinTxt( $1F, 41, 10, ' ENC0ٳ');
  ScrWinTxt( $1F, 41, 11, ' MAS ٳ');
  ScrWinTxt( $1F, 41, 12, ' I2C ');


  ScrWInTxt( $1F, 21,  5, '0=4x40 LCDٳ');
  ScrWInTxt( $1F, 21,  6, '0=No Busy ٳ');
  ScrWInTxt( $1F, 21,  7, '--        ٳ');
  ScrWInTxt( $1F, 21,  8, '--        ٳ');
  ScrWInTxt( $1F, 21,  9, '--        ٳ');
  ScrWinTxt( $1F, 21, 10, '0=Matx 138ٳ');
  ScrWinTxt( $1F, 21, 11, '0=ENC>KEYٳ');
  ScrWInTxt( $1F, 21, 12, '0=MATRIX  ');

  ScrWinTxt( $70, 3,   9, ' PUMP LCD  01FF ');

  ScrWinTxt( $1F,  3, 23, 'ATMEL Firmware: ');
  ScrWinTxt( $1e, 19, 23, ldby( GetVersion));


  for i := 0 to 3 do begin KeyBuf[i] := 0; IrBuf[i] := 0; EncBuf[i] := 0; end;
  ShowKeyBuf;
  ShowIRBuf;
  ShowEncBuf;
  KeyTgl := $70;
  IrTgl  := $70;
  Enctgl := $70;
  ScrWinTxt( IRtgl, 56, 8, 'IR:  ADDR      CODE    ');
  ScrWinTxt( KeyTgl, 68, 3, 'Key:       ');
  ScrWinTxt( Enctgl, 56, 3, 'Enc:       ');

  MenuLine( $70, $74, 25, MainMenu);

  ShowPUMPcfg;

  counter := 0;

  ShowLCDdim;

  repeat

    kc := keyIn(c);
    scroller;
    ShowLPTConf;

    counter := counter + 1;

    if Time <> LastTime then begin
      ScrWinTxt( $70, 4, 1, lreal( 1/counter*1000, 2, 4)+'ms    ');
      counter := 0;
      LastTime := Time;
    end;


    ShowPumpStat;
    if PUMPkey then begin
      ScrWinTxt( KeyTgl, 68, 3, 'Key:       ');
      KeyTgl := KeyTgl xor $04;
      delay(20);      { for better viewing of the status bit }
      Move( KeyBuf[0], KeyBuf[1], 3);
      KeyBuf[ 0] := GetPUMPKey;
      ShowKeyBuf;
    end;

    if PUMP_IR then begin
      ScrWinTxt( IRtgl, 56, 8, 'IR:');
      IrTgl := IRtgl xor $04;
      delay( 20);
      Move( irBuf[0], irBuf[1], 6);
      IrBuf[0] := GetPUMPir;
      ShowIRBuf;
    end;

    if PUMPenc then begin
      ScrWinTxt( Enctgl, 56, 3, 'ENC:');
      EncTgl := Enctgl xor $04;
      delay( 20);
      Move( EncBuf[0], EncBuf[1], 3);
      EncBuf[0] := GetPUMPenc;
      ShowEncBuf;
    end;

    case kc of
      F10   : ResetPUMP;
      F9    : begin ConfigPUMP; ShowLCDdim; end;
      F7    : readserial := not readserial;
      F6    : LCD_Test;
      F5    : GLCD_Test;
    end;

    if kc in [ F9, F6, F5] then MenuLine( $70, $74, 25, MainMenu);

  until kc = AltX;
  CursorOn;
end;



Begin
end.